<template>
  <div class="m-project">
    <h2 class="m-project__title">{{ project.attributes.label }}</h2>

    <div class="m-project__wrap">
      <div class="m-project__chart" v-if="dailyCoverageData">
        <h3 class="m-project__chartTitle">Code Coverage [%]</h3>
        <vue-chartist :data="dailyCoverageData" :options="dailyCoverageOptions" type="Line"></vue-chartist>
      </div>
      <div class="m-project__chart" v-if="linesOfCodeData">
        <h3 class="m-project__chartTitle">Covered LoC</h3>
        <vue-chartist :data="linesOfCodeData" :options="linesOfCodeOptions" type="Line"></vue-chartist>
      </div>
      <div class="m-project__chart m-project__chart--tests" v-if="testsuitesData">
        <h3 class="m-project__chartTitle">Executed Tests</h3>
        <vue-chartist :data="testsuitesData" :options="testsuitesOptions" type="Line"></vue-chartist>
      </div>
      <div class="m-project__chart m-project__chart--tests" v-if="lastTestData">
        <h3 class="m-project__chartTitle">Last Test Results</h3>
        <vue-chartist :data="lastTestData" :options="lastTestOptions" type="Bar"></vue-chartist>
      </div>
    </div>
  </div>
</template>
<script>
import VueChartist from 'v-chartist'
import Chartist from 'chartist'
import axios from 'axios'

require('chartist-plugin-tooltips')
require('chartist-plugin-legend')
require('chartist-plugin-axistitle')

export default {
  name: 'Project',
  components: {
    VueChartist
  },
  props: {
    project: Object
  },
  data () {
    return {
      timeout: null,
      dailyCoverageData: null,
      linesOfCodeData: null,
      testsuitesData: null,
      lastTestData: null,
      dailyCoverageOptions: {
        height: 350,
        scaleMinSpace: 80,
        lineSmooth: Chartist.Interpolation.simple({
          divisor: 2
        }),
        fullWidth: true,
        chartPadding: {
          right: 40
        },
        low: 0,
        plugins: [
          Chartist.plugins.tooltip({
            appendToBody: true
          }),
          Chartist.plugins.legend({
            position: 'bottom',
            legendNames: ['total', 'conditionals', 'methods', 'elements'],
            clickable: false
          })
        ]
      },
      linesOfCodeOptions: {
        height: 350,
        scaleMinSpace: 80,
        lineSmooth: Chartist.Interpolation.simple({
          divisor: 2
        }),
        fullWidth: true,
        chartPadding: {
          right: 40
        },
        low: 0,
        plugins: [
          Chartist.plugins.tooltip({
            appendToBody: true
          })
        ]
      },
      testsuitesOptions: {
        height: 350,
        scaleMinSpace: 80,
        lineSmooth: Chartist.Interpolation.simple({
          divisor: 2
        }),
        fullWidth: true,
        chartPadding: {
          right: 40
        },
        low: 0,
        showArea: true,
        plugins: [
          Chartist.plugins.tooltip({
            appendToBody: true
          }),
          Chartist.plugins.legend({
            position: 'bottom',
            legendNames: ['total tests', 'errors', 'failures', 'skipped'],
            clickable: false
          })
        ]
      },
      lastTestOptions: {
        height: 350,
        fullWidth: true,
        plugins: [
          Chartist.plugins.tooltip({
            appendToBody: true
          })
        ]
      }
    }
  },
  watch: {
    project: function () {
      this.load()
    }
  },
  methods: {
    buildDailyCoverageDatasets (totalCoverage, conditionalCoverage, methodCoverage, elementCoverage) {
      const totalCoverageDS = this.buildDataset(totalCoverage)
      const conditionalCoverageDS = this.buildDataset(conditionalCoverage)
      const methodCoverageDS = this.buildDataset(methodCoverage)
      const elementCoverageDS = this.buildDataset(elementCoverage)

      if (totalCoverageDS) {
        return [totalCoverageDS, conditionalCoverageDS, methodCoverageDS, elementCoverageDS]
      }

      return []
    },
    buildDataset (values) {
      const filtered = values.filter((value) => { return value !== '0.00' })

      if (filtered.length === 0) {
        return []
      }

      return values.reverse()
    },
    prepareCoverageDailyData (response) {
      let labels = []
      let totalCoverage = []
      let conditionalCoverage = []
      let methodCoverage = []
      let elementCoverage = []
      let linesOfCode = []

      response.data.data.map(data => {
        const date = new Date(data.attributes['created-at'])
        const label = date.getDate() + '.' + (date.getMonth() + 1)

        labels.push(label)
        totalCoverage.push(parseFloat(data.attributes.coverage).toFixed(2))
        conditionalCoverage.push(parseFloat(data.attributes['conditional-coverage']).toFixed(2))
        methodCoverage.push(parseFloat(data.attributes['method-coverage']).toFixed(2))
        elementCoverage.push(parseFloat(data.attributes['element-coverage']).toFixed(2))
        linesOfCode.push(parseFloat(data.attributes['lines-of-code']).toFixed(0))
      })

      labels = labels.reverse()

      let series = this.buildDailyCoverageDatasets(totalCoverage, conditionalCoverage, methodCoverage, elementCoverage)

      this.dailyCoverageData = { labels, series }

      series = []

      const linesOfCodeDS = this.buildDataset(linesOfCode, 'Lines of Code', 'rgba(54, 162, 235, 1)', true)

      if (linesOfCodeDS) {
        series = [linesOfCodeDS]
      }

      this.linesOfCodeData = { labels, series }
    },
    prepareTestsuiteData (response) {
      let tests = []
      let errors = []
      let failures = []
      let skipped = []
      let labels = []

      if (response.data.data.length === 0) {
        this.testsuitesData = null
        this.lastTestData = null
        return
      }

      response.data.data.map((data, index) => {
        labels.push(index + 1)
        tests.push(data.attributes.tests)
        errors.push(data.attributes.errors)
        failures.push(data.attributes.failures)
        skipped.push(data.attributes.skipped)
      })

      let series = [tests.reverse(), errors.reverse(), failures.reverse(), skipped.reverse()]

      this.testsuitesData = { labels, series }

      const firstRecord = response.data.data[0]

      this.lastTestData = {
        labels: ['tests', 'errors', 'failures', 'skipped'],
        series: [[
          firstRecord.attributes.tests,
          firstRecord.attributes.errors,
          firstRecord.attributes.failures,
          firstRecord.attributes.skipped,
        ]]
      }
    },
    load () {
      if (this.timeout) {
        clearTimeout(this.timeout)
      }

      let url = this.project.links['coverage-daily']
      if (process.env.NODE_ENV === 'development') {
        url = 'http://localhost:1515' + url
      }

      axios.get(url).then(this.prepareCoverageDailyData)

      url = this.project.links['testsuites']
      if (process.env.NODE_ENV === 'development') {
        url = 'http://localhost:1515' + url
      }

      axios.get(url).then(this.prepareTestsuiteData)

      this.timeout = setTimeout(this.load, 5000)
    }
  },
  mounted () {
    this.load()
  }
}
</script>
<style lang="scss">
  @import './../assets/scss/chart';

  .m-project {
    &__wrap {
      display: flex;
      flex-wrap: wrap;
    }

    &__chartTitle {
      font-weight: 700;
      font-size: 1rem;
      text-align: center;
    }

    &__chart {
      padding: 0.5rem;
      flex: 1 0 100%;

      @media (min-width: 1000px) {
        flex: 1 0 45%;
      }

      &--tests {
        & .ct-series-a .ct-line, .ct-series-a .ct-point, .ct-series-a .ct-bar {
          stroke: #8BC34A;
        }

        & .ct-series-a .ct-area {
          fill: #8BC34A;
        }

        & .ct-series-b .ct-line, .ct-series-b .ct-point, .ct-series-b .ct-bar {
          stroke: #F44336;
        }

        & .ct-series-b .ct-area {
          fill: #F44336;
        }

        & .ct-series-c .ct-line, .ct-series-c .ct-point, .ct-series-c .ct-bar {
          stroke: #B71C1C;
        }

        & .ct-series-c .ct-area {
          fill: #B71C1C;
        }

        & .ct-series-d .ct-line, .ct-series-d .ct-point, .ct-series-d .ct-bar {
          stroke: #FF9800;
        }

        & .ct-series-d .ct-area {
          fill: #FF9800;
        }

        & .ct-legend .ct-series-0:before {
          background-color: #8BC34A;
          border-color: #8BC34A;
        }

        & .ct-legend .ct-series-1:before {
          background-color: #F44336;
          border-color: #F44336;
        }

        & .ct-legend .ct-series-2:before {
          background-color: #B71C1C;
          border-color: #B71C1C;
        }

        & .ct-legend .ct-series-3:before {
          background-color: #FF9800;
          border-color: #FF9800;
        }
      }
    }
  }
</style>
